/*

  P-Code interpreter (to run the apple pascal system)
  Copyright (C) 2000 Mario Klebsch

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Log: Memory.h,v $
  Revision 1.2  2001/05/20 13:12:02  mario
  CVS-Idents und Logs eingefgt


*/


#define WORD_MEMORY

extern int SwapBytes;

byte MemRdByte(word Addr, Integer Offset);
void MemWrByte(word Addr, Integer Offset, byte Value);
word MemRd(word Addr);
void MemWr(word Addr, word Value);
void MemReadOnly(word from, word to, int RO);
void MemDump(FILE *f, word Start, word End);
void MemInit(void);

#define NIL		0

#define PointerCheck(Pointer) if ((Pointer) == NIL) XeqError(7)

#ifdef WORD_MEMORY
#define WordIndexed(Pointer, Offset) ((Pointer) + (Offset))
#else
#define WordIndexed(Pointer, Offset) ((Pointer) + 2*(Offset))
#endif
